In the bills API endpoints, we have introduced the purchaseOrderNumber field. You can now set this field as a purchase order number linked with the bill.
See POST /v3/bills in the API reference for more information.
In the bills API endpoints, we have introduced the purchaseOrderNumber field. You can now set this field as a purchase order number linked with the bill.
See POST /v3/bills in the API reference for more information.
The vendor webhook notifications now include the shortName field. This field is the vendor short name. When you receive notifications for the vendor.created, vendor.updated, vendor.archived, or vendor.restored events, the notifications now include the shortName field.
See Vendor notification payloads for more information.
The bill webhook notifications now include the purchaseOrderNumber field. This field is the purchase order number linked with the bill. When you receive notifications for the bill.created, bill.updated, bill.archived, or bill.restored events, the notifications now include the purchaseOrderNumber field.
See AP bill notification payloads for more information.
On the MFA setup screen, when the user enters and international (not US) phone number and selects Voice call to receive a verification code, we have ensured that the correct information banner is displayed on the screen.
In February 2025, BILL introduced UUIDs in the Spend & Expense API for further improving its security standards. All API responses include both id and uuid values.
As of July 9, 2025, the Spend & Expense id values are being deprecated. Both id and uuid values will continue to be available in all API responses. We strongly recommend that you use uuid instead of id in all your Spend & Expense API operations.
BILL maintains an event history for each subscription. We have now upgraded the webhooks TTL from 90 days to 180 days. You can get the list of event notifications sent to you for a subscription with GET /v3/events/subscription/{subscription_id}. You can now get the list of events for the last 180 days.
See Webhook API notification rules for more information about the complete set of rules.
We have added the capability for filtering event notifications by an entity ID. For example, to get notifications for a specific bill, you can now filter with the ID of the bill.
In the Get list of event notifications (GET /v3/events/subscription/{subscription_id}) request, you can now filter event notifications with the entityId field.
| Field | Description |
|---|---|
entityId | BILL-generated ID of the entity, such as bill or vendor. For example, to filter notifications by a specific bill, set this value as the ID of the bill. |
See GET /v3/events/subscription/{subscriptionId} in the API reference for more information.
We have introduced a set of API endpoints for getting billing statement information for an organization. BILL generates a monthly billing invoice statement for all the billing activities in the organization.
| Operation | API endpoint |
|---|---|
| Get list of billing statements | GET /v3/organizations/{organizationId}/billing-statements |
| Get billing statement details | GET /v3/organizations/{organizationId}/billing-statements/{billingStatementId} |
See Organization billing statements for more information.
We have introduced a new API endpoint for recording an AP payment.
You can now record a bill payment made outside your BILL system. You can apply the recorded payment amount to one or more bills for a vendor.
| Operation | API endpoint |
|---|---|
| Record AP payment | POST /v3/bills/record-payment |
See Record AP payments for more information.
We have introduced a new API endpoint for getting the current BILL foreign exchange rate.
You can now get the current BILL foreign exchange rate for a payment made to an international vendor. The BILL foreign exchange rate changes periodically. Use this endpoint to get the current exchange rate based on the payment amount and vendor payment currency.
| Operation | API endpoint |
|---|---|
| Get BILL foreign exchange rate | GET /v3/payments/exchange-rate |
The mfaSuccess event is emitted when the MFA setup or MFA challenge is submitted successfully. We have added rememberMeId and deviceId in the event payload.
{
setup: boolean;
required: boolean;
rememberMe?: boolean;
rememberMeId: string;
deviceId: string;
}| Field | Description |
|---|---|
rememberMeId | MFA ID generated when the remembeMe is set as true for the user. |
deviceId | Mobile device name. This is a nickname for the mobile device used to receive the validation token to the registered phone number. |
Note that rememberMeId is available in the payload only when MFA rememberMe is set as true for the user.
We have introduced a set of API endpoints for recurring invoice operations. A recurring invoice is a template for creating identical invoices for accepting recurring payments from a customer. Each invoice represents an amount that you are owed by a customer for goods and services that your organization provides.
| Operation | API endpoint |
|---|---|
| Create a recurring invoice | POST /v3/recurring-invoices |
| Get list of recurring invoices | GET /v3/recurring-invoices |
| Get recurring invoice details | POST /v3/recurring-invoices/{recurringInvoiceId} |
| Update a recurring invoice | PATCH /v3/recurring-invoices/{recurringInvoiceId} |
| Replace a recurring invoice | PUT /v3/recurring-invoices/{recurringInvoiceId} |
| Archive a recurring invoice | POST /v3/recurring-invoices/{recurringInvoiceId}/archive |
| Restore a recurring invoice | POST /v3/recurring-invoices/{recurringInvoiceId}/restore |
See Recurring invoices for more information.